% La fonction "exo23_q1" utilise une méthode de Monte-Carlo naïve pour
% évaluer l'espérance de P, avec une marge d'erreur à 2 sigmas. La fonction
% prend en argument le nombre "N" de simulations souhaitées. Je ne commente
% que les parties inhabituelles.
function exo23_q1(N)
S = 0;
S2 = 0;
% "logs" est le vecteur-ligne apparaissant au début de la formule (1).
logs = [log(800),log(1000),log(1200)];
% "C" est la matrice de covariance qui apparait dans la formule (1).
C = [.2,.1,.1;.1,.2,.1;.1,.1,.2];
% "R" est une matrice telle que R'*R = C. Comme on aura besoin de se servir
% de cette matrice à chaque passage dans la boucle, on la calcule une fois
% pour toutes /à l'extérieur/ de la boucle.
R = chol(C);
for i = 1:N
    % "P" est le prix simulé. Décortiquons cette simulation étape par étape
    % : "randn(1,3)" est un vecteur gaussien 3-dimensionnel centré réduit.
    % En le multipliant à droite par la matrice "R", on obtient un vecteur
    % gaussien centré de matrice de covariance R'*R = C, ce qui nous donne
    % donc la partie aléatoire de la formule (1). Puis en ajoutant "logs"
    % on a simulé complètement le vecteur (ln X, ln Y, ln Z). En appliquant
    % la fonction "exp" à ce vecteur (sachant que la fonction "exp" de
    % MATLAB s'applique coordonnée par coordonnée dans le cas d'un vecteur
    % ou d'une matrice), on a simulé (X,Y,Z). Et il n'y a plus qu'à prendre
    % le minimum pour simuler P.
    P = min(exp(logs + randn(1,3) * R));
    S = S + P;
    S2 = S2 + P*P;
end
m = S / N;
sigma = sqrt(S2 / N - m * m);
erreur = 2 * sigma / sqrt(N);
disp(['Prix moyen : ',num2str(m),' ± ',num2str(erreur)]);
return
end